var g_files_to_download = 0;
var g_files_downloaded = 0;
var g_downloading_files = 0;
var sPath = "";
var dateModified;
var uii_name;
var uii_json;
var date_downloaded;
var id_uiimage;


// onerror tries to load the %LOCALFILE% first, if that fails it tries to load the same file in the bundle img/ directory.  If that fails notfound.jpg or the specified notfound image is shown
function image_onerror(image, notfound_image_filename) 
{
	var currentname = image.src;
	dalert( 'not found image:'+currentname );
	var array_parts = currentname.split('/');
	var last_part = array_parts[ array_parts.length - 1 ];
	var in_img_bundle = "img/"+last_part;
	dalert( 'looking for:'+in_img_bundle );
	
	// Try to load from bundle
	image.src = in_img_bundle;
	
	// Attempt to load the same image but locally
    image.onerror = "image_onerror2(this,"+notfound_image_filename+")";
    return true;
}

// Called when image_onerror fails too
function image_onerror2(image, notfound_image_filename )
{
	var currentname = image.src;
	dalert('not found in bundle:'+currentname);
	
	var usefile = 'img/notfound.jpg';
	if( notfound_image_filename == null )
	{
		notfound_image_filename = usefile;
	}

	var usefile = 'img/notfound.jpg';
    image.onerror = "";
    image.src = usefile;
}


function notify_file_added(localfilename)
{
	g_files_to_download = g_files_to_download + 1;
	update_progress_bar();
}
function notify_file_downloaded(localfilename)
{
	g_files_downloaded = g_files_downloaded + 1;
	update_progress_bar();
}

function update_progress_bar()
{
	if( g_files_to_download > 0 )
	{
		progressbar_start();
		progressbar_update_text( "Images "+ (g_files_downloaded + 0) +" of " + g_files_to_download );
		var percentage = ( g_files_downloaded + 1 )/ g_files_to_download;
		progressbar_update_percentage( percentage );
	}
	// Everything is done so reset
	if( ( g_files_downloaded == g_files_to_download ) && ( g_files_to_download > 0 ) )
	{
		progressbar_stop();
		g_files_to_download = 0;
		g_files_downloaded = 0;

		// Reload the app
        if( !m_prevent_refresh_if_resynced )
        {
            // Reload the current page just incase any content has changed
            app_reload_current_page();
        }

	}
}

function successdb(suc)
{
	if( m_debug_loading )
	{
	    dlog("UPDATE successdb "+JSON.stringify(suc));
	}
}



function errordb(err)
{
	if( m_debug_loading )
	{
	    dalert("error successdb "+JSON.stringify(err));
	}
}


// Downloads lots of images from the uiimages database to local store
function download_new_uiimages()
{
    db.transaction(
        function (tx)
        {

            tx.executeSql("SELECT * FROM uiimages;", [], 
                function callback(tx, results)
                {
                    var len = results.rows.length;

                    // Data
					if( g_force_images_to_always_redownload )
					{
						alert('Forcing downloading of images, disable g_force_images_to_always_redownload for release');
					}
					
                    var array_all_days = [];
                    var counter = 0;
                    while( counter < len )
                    {
                        try
                        {
                            var item = results.rows.item(counter);
                            var id_uiimage_temp=item['id_uiimage'];
                            var uii_name_temp = item['original_name'];
                            var date_modified_temp = item['date_modified'];
                            var date_downloaded_temp =item['date_downloaded'];

							if( m_debug_loading )
							{
	                            dlog("testing if we need to download :" + uii_name_temp);
							}


                            if( (date_modified_temp!=date_downloaded_temp) ||( g_force_images_to_always_redownload ) )
                            {
								if( m_debug_loading )
								{
	                                dlog("not equal to");
								}
								uii_json = jQuery.parseJSON(item['image']);

								var siteURL_temp = g_url_triangulate_root+uii_json[0]['name'];
                                download_single_file(siteURL_temp, uii_name_temp, date_modified_temp, id_uiimage_temp);
								g_downloading_files = g_downloading_files + 1;
                            }
                            else
                            {
								if( m_debug_loading )
								{
	                                dlog("Not needing to update:"+uii_json)
								}
                            }
                        }
                        catch( e )
                        {
                            dalert("Exception in uiimage download:"+e.message);
                        }
                        counter++;
                    }
                },
                function onerror(err)
                {
                    dalert( "Error from database"+err.message );
                }				
            );

        }
    );
}



// Downloads a single file from the url to the local disk
function download_single_file(url, localfilename, date_modified_temp, id_uiimage_temp)
{
	notify_file_added(localfilename);
	if( m_debug_loading )
	{
	    dalert('downloading file:'+localfilename);
	}
	
	
	
    if (typeof FileTransfer != 'undefined')
	{
		var fileTransfer = new FileTransfer();
		fileTransfer.onprogress = function(progressEvent)
		{
			if (progressEvent.lengthComputable)
			{
				var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
			}
			else
			{
				
			}
			
			if(perc>=100)
			{
				//  alert("100%");
			}
		};

		//end of progress
		get_local_path(
			function( local_path )
			{
				// TODO: Test if works on iOS/Android too!
				// Wp8
				if( is_wp8() )
				{
					local_path = local_path.replace("cdvfile://localhost/persistent/", "//");
				}
			
			
				// Local path obtained now
//alert('local path:'+local_path);
				if( m_debug_loading )
				{
					dlog('loading localfilename:'+localfilename);
					dlog('encodeURI(url):'+encodeURI(url));
				}
				if( typeof( g_debug_showpathsused ) != 'undefined' )
				{
					alert('SR:encodeURI(url):'+encodeURI(url));				
					alert('SR:local_path + localfilename:'+local_path + localfilename);				
				}
				var full_path_and_filename = local_path + localfilename;
				

				
				fileTransfer.download(
					encodeURI(url),
					full_path_and_filename,

					function(theFile)
					{
						notify_file_downloaded(localfilename);
						//this is where you can do stuff with the downloaded file

						//dalert("success what to do with file");
						//put a  flag in table, if date modified is different
						// uiimages->deleted = uiimages->dateModified.
						//when you do select stament check datemodied.
						dlog( 'downloaded:'+localfilename);
						db.transaction(
							function (tx)
							{
								if( !m_use_webserver_sql )
								{
									//alert(id_uiimage_temp);
									tx.executeSql("UPDATE uiimages SET date_downloaded = ? WHERE id_uiimage = ?",[date_modified_temp,  id_uiimage_temp],successdb, errordb );
								}
							}
						);
						if( device.platform == "iPhone" )
						{
						theFile.setMetadata(
							function success()
							{
								if( m_debug_loading )
								{
									dlog('meta data set');
								}
							},
							function failed()
							{
								if( m_debug_loading )
								{
									dalert('Metadata iCloud setting failed (for iOS)');
								}
								
							},
							{ "com.apple.MobileBackup": 1}
						);
						}
					},
					function(error) 
					{
						notify_file_downloaded(localfilename);
						if( typeof( g_debug_showpathsused ) != 'undefined' )
						{
							alert("SR:Error: "+JSON.stringify(error));
						}
					}
				);
			}
		);
	}
	else
	{
		dalertonce("No FileTransfer Object found");
		notify_file_downloaded();
	}
}
/* OLD did work for iOS/Android


// Downloads a single file from the url to the local disk
function download_single_file(url, localfilename, date_modified_temp, id_uiimage_temp)
{
	notify_file_added(localfilename);
	if( m_debug_loading )
	{
	    dalert('downloading file:'+localfilename);
	}
	
    if (typeof FileTransfer != 'undefined')
	{
		var fileTransfer = new FileTransfer();
		fileTransfer.onprogress = function(progressEvent)
		{
			if (progressEvent.lengthComputable)
			{
				var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
			}
			else
			{
				
			}
			
			if(perc>=100)
			{
				//  alert("100%");
			}
		};

		//end of progress
		get_local_path(
			function( local_path )
			{
				// Local path obtained now
//alert('local path:'+local_path);
				if( m_debug_loading )
				{
					dlog('loading localfilename:'+localfilename);
					dlog('encodeURI(url):'+encodeURI(url));
				}
alert('SR:encodeURI(url):'+encodeURI(url));				
alert('SR:local_path + localfilename:'+local_path + localfilename);				
				fileTransfer.download(
					encodeURI(url),
					local_path + localfilename,

					function(theFile)
					{
						notify_file_downloaded(localfilename);
						//this is where you can do stuff with the downloaded file

						//dalert("success what to do with file");
						//put a  flag in table, if date modified is different
						// uiimages->deleted = uiimages->dateModified.
						//when you do select stament check datemodied.
						dlog( 'downloaded:'+localfilename);
						db.transaction(
							function (tx)
							{
								if( !m_use_webserver_sql )
								{
									//alert(id_uiimage_temp);
									tx.executeSql("UPDATE uiimages SET date_downloaded = ? WHERE id_uiimage = ?",[date_modified_temp,  id_uiimage_temp],successdb, errordb );
								}
							}
						);
						if( device.platform == "iPhone" )
						{
						theFile.setMetadata(
							function success()
							{
								if( m_debug_loading )
								{
									dlog('meta data set');
								}
							},
							function failed()
							{
								if( m_debug_loading )
								{
									dalert('Metadata iCloud setting failed (for iOS)');
								}
								
							},
							{ "com.apple.MobileBackup": 1}
						);
						}
					},
					function(error) 
					{
						notify_file_downloaded(localfilename);
						alert("SR:Error: "+JSON.stringify(error));
					}
				);
			}
		);
	}
	else
	{
		dalertonce("No FileTransfer Object found");
		notify_file_downloaded();
	}
}

*/