	var m_localisation_data={ 
		"My Event":"Mon Event",
		"Activity":"Doing stuff"
	};
	var m_localisation_loaded = false;
	
	
	
	//globalStorage['developer.mozilla.org'].setItem("username", "John");
	
	function load_local_language()
	{
		
		var language_code = window.navigator.userLanguage || window.navigator.language;
		//alert( "Found language:"+language_code );
		
		set_language( language_code );
	}
	
	
	function set_language( language_code )
	{
		var filetoload = "lang_en.json";
		
		var lang_array = { 
							en: "en.json",
							zh: "zh.json",
							es: "es.json",
							de: "de.json",
							fr: "fr.json"
		};
		
		var langtest = language_code.toLowerCase().substring(0,2);
		if( lang_array[langtest] != null )
		{
			filetoload = "lang_"+langtest+".json";
		}

		
		var url = "js/localisation/"+filetoload;
		
		url = url.replace( /x-wmapp0:\/\//, "" );
		$.ajax({
		  dataType: "json",
		  url: url,
		  data: "",
		  success: function( loaded_json )
		  {
			m_localisation_data = loaded_json;
			m_localisation_loaded = true;
		  },
		  error: function(err)
		  {
			dalert( "error loading file:"+filetoload );
		  }
		});		
	}
	
	
	
	// Call to convert any text elements to another langauge.
	// typeically this means <div class="localise">blah</div>  would search for blah in the localisation file and replace it if found
	function localise_pages( dom_to_start_from )
	{
		if( m_localisation_loaded )
		{
			$( ".localise" ).each(
				function( index, element )
				{
					//alert( "found"+index);
					var lookup = $(this).text();
					var translated = localise_text( lookup );
					
					if( translated != null )
					{
						$(this).text(translated);
					}
					else
					{
						if( !m_debug )
						{
							$(this).text( lookup );
						}
						else
						{
							$(this).text( "!"+lookup );
						}
					}
					$(this).removeClass("localise");
				}
			);
		}
		else
		{
			dalert( "No localisation data loaded" );
		}
	}


	// Will translate some text if it's found in the dictionary
	function localise_text( text_in )
	{
		if( text_in != null )
		{			
			var trimmed = text_in.trim();
			
			var newtext = text_in;
			if( m_localisation_data[trimmed]!=null )
			{
				newtext = m_localisation_data[trimmed];
			}
		}
		else
		{
			newtext = "";
		}
		return newtext;
	}