var g_main_menu_first_time_app_run = true; // Set to false the first time the mainscreen is shown
var ma_parameters = [];
var m_slider; // This is the viewcontroller that slides pages in and out
var m_version;	// This stores the app version number
var m_has_loaded = false; // Flag to say if ondeviceready has been called yet
var g_running_cordova = false;
var aszart_network_online = true;

var m_minutes_until_try_resync = 10; // Only resync data if more than 10 minutes has passed since the last sync attempt

// Get the utc time now
function get_utc_now()
{
	var d = new Date();
	var t = d.getTime() / 1000;
	return t;
}

function onresume()
{
    // Handle the resume event
	var seconds_since_sync = (get_utc_now() - g_utc_last_sync_completed);
	if( seconds_since_sync > (m_minutes_until_try_resync * 60 ) )
	{
dalert('syncing due to resume and '+( seconds_since_sync / 60 ) + ' minutes have passed which is more than '+m_minutes_until_try_resync+' minutes have passed' );
		sync_data();
	}
	else
	{
		dalert('not resyncing as only ' + seconds_since_sync + ' seconds have passed but waiting for '+(m_minutes_until_try_resync * 60) );
	}
		
}

function onpause()
{
	FlurryAgent.pauseSession();
}
function load_bing_maps_script()
{
	var url = "http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0";
		
	//http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0
	var script = document.createElement("script");
            script.setAttribute("src", url+"&onScriptLoad=initMap");
            script.setAttribute("type", "text/javascript");
            document.documentElement.firstChild.appendChild(script);
	
/*	
	$.getScript( url, function() 
		{
			//dalert('bing loaded successfully');
		},
		function onerror()
		{
			dalert('bing unable to load bing');
		}
	);
	*/
}


function select_event(event_id, callback_when_done)
{
	g_event_id = event_id;
	get_local_path(
		function( local_path )
		{
			// Make sure the data directory is se
			var a = new DirManager(); // Initialize a Folder manager
			var withoutcdv = local_path.replace("cdvfile://localhost/persistent/", "");
			a.create_r(withoutcdv, 
				function()
				{
					dlog('created successfully'+withoutcdv);
					//alert('SR:created successfully'+withoutcdv);
					callback_when_done();
				},
				function onerror()
				{
					alert('Error saving files locally.  This may hinder updates:'+withoutcdv);
					callback_when_done();
				}
			);	
		} 
	);
}


function get_container_max_width()
{
	if( m_is_website )
	{
		if( window.innerWidth > 800 )
		{
			return 800;
		}
	}
	return window.innerWidth;
}

function on_desktop_change_css()
{
	//var width = $( window ).width();
	var max_width = get_container_max_width();
	var width = window.innerWidth;
	var offset_x = 0;
	
	if( width > max_width )
	{
		offset_x = ( width - max_width ) / 2;
		width = max_width;
	}
	if( $('#container') != null )
	{
		//$('#container').css("overflow", "hidden"); // Remove this, it prevents any scrolling!
		$('#container').css("overflow", "scroll");
		$('#container').css("width", width+"px");
		$('#container').css("left", offset_x+"px");
		$('#container').css("border-style","solid");
		var border_around_content = true;
		if( border_around_content )
		{
			$('#container').css("border","2px solid rgb(178, 190, 187)");
			$('#container').css("border-top-left-radius","6px");
			$('#container').css("border-top-right-radius","6px");
			$('#container').css("border-bottom-right-radius","6px");
			$('#container').css("border-bottom-left-radius","6px");
		}
		else
		{
			$('#container').css("border-style","none");
		}
		
	}
	else
	{
		dalert( 'on_desktop_change_css(): Container not found to resize' );
	}
	if( $('#main_background') != null )
	{
		$('#main_background').css("width", width+"px");
		$('#main_background').css("left", offset_x+"px");
	}


	var height = window.innerHeight;
	//$('#container').css("height", height+"px"); // This stopped the scrolling in WP8 working
	//$('body').css("height", height+"px"); // This stopped the scrolling in WP8 working (Was in, removed now)
	var progress_height = 44;
	var margin = 8;
	$('#progress_overlay').css("height", progress_height+"px"); // This stopped the scrolling in WP8 working
	$('#progress_overlay').css("top", height-progress_height+"px"); // This stopped the scrolling in WP8 working
	$('#progress_info').css("top", height-progress_height+"px"); // This stopped the scrolling in WP8 working

	if( !m_debug )
	{
		$('#version_text').hide();
	}

	if( m_show_fixed_banner_at_bottom )
	{
		$('#container').css("height", "80%");
		$('#fixedbanner').css("top","80%");
		$('#fixedbanner').css("height","20%");
		$('#fixedbanner').html("<img id='fixedbannerimage' src='img/fixed_ad.jpg'></img>");
	}
	else
	{
		$('#fixedbanner').hide();
	}
	
}



function warn_about_debug_options()
{
	if( m_disable_localnotifications )
	{
		alert( '*** LOCAL NOTIFICATIONS ARE DISABLED ***');
	}
	else if( m_debug_localnotifications_force_in_30_seconds )
	{
		alert( '*** LOCAL NOTIFICATIONS ARE SET FOR +30 SECONDS ***');
	}
}

function onOnline() 
{
    // Handle the online event
    var networkState = navigator.connection.type;

    if (networkState !== Connection.NONE) 
	{
        // We are online
		aszart_network_online = true;
		
		// Trigger a resync test?
		
    }
}

function onOffline() 
{
    // Handle the offline event
    console.log("lost connection");
	aszart_network_online = false;
}

// 
function on_app_first_load()
{
    try
    {
		document.addEventListener("offline", onOffline, false);
		document.addEventListener("online", onOnline, false);
		
		// Listen out for the click event on any local notifications to process these correctly
		LocalNotifications.ListenForEvents();
				
		warn_about_debug_options();
		
		// Attempt to load bing maps
		load_bing_maps_script();

		
		// Make sure the cordova temp backup data isn't stored in iCloud
		diskutils_stop_icloud_backups_being_saved();

		g_gpshelper = new GpsHelper();


		create_db_if_necessary( function()
			{ 
				EventDate.set_event_timezone_for_event() 
			} 
		);
		
		FlurryAgent.startSession(g_flurry_id); // Labour Web Key
		FlurryAgent.setUserId(get_unique_id_for_this_device()); // Tag the device so we can distinguish events yet keep it anonymous
		//FlurryAgent.setRequestInterval(15);
		
        load_local_language();

        // Start the database sync
        if( cordova.getAppVersion != null )
        {
            cordova.getAppVersion(
                function (version) 
                {
                    $('#version_text').text("Debug V"+version);
                    if( m_debug )
                    {
                        $('#version_text').show();
                    }
					else
					{
                        $('#version_text').hide();
					}

                    m_version = version;
					var platform = "unknown";
					try
					{
						platform = device.platform;
					}
					catch(e)
					{
					}
					FlurryAgent.setAppVersion(version + ':' + platform);

                     // Only sync the data when we know this has worked
					select_event( g_event_to_start, sync_data );
				}
            );
        }
        else
        {
			// We are not using the Cordova routines to save the files therefore just set the event here.
			g_event_id = g_event_to_start;

            if( m_debug && !m_is_website )
			{
				dalert( "No App Version Plugin found" );
				$('#version_text').text("Debug (No version info)");
				$('#version_text').show();
			}
            sync_data();
        }
        
        // Invoke the first page load
        on_hash_changed("mainmenu.html");

        // Set up the routing system so any window hash changes get directed here
        $(window).on('hashchange', on_hash_changed);

		// If we're on a desktop resize to look better
		on_desktop_change_css();
		window.onorientationchange = function()
		{
			on_desktop_change_css();
		};		
		window.onresize = function()
		{
			on_desktop_change_css();
		};

		
		
        

        document.addEventListener("resume", onresume, false);
		document.addEventListener("pause", onpause, false);

        // Set up quick button presses
		
		//if( IsWP8() )
		{
			// We don't want to use fastclick on wp8 since it causes problems on scroll lists
			//alert("disabled fastclick");
		}
		//else
		{	
			FastClick.attach(document.body);
		}
	   	if( g_use_urbanairship )
		{
	        urban_airship_setup();
		}

        //dalert("Yes, Cordova is running");
    }
    catch( e )
    {
        dalert( "There was an error initializing the app" );
    }
		
}


function app_database_error( err )
{
	if( err.message != null )
	{
		dalert( "DB Error:"+err.message );
	}
	showalert( "No Data Syncrhonised Yet", "No data has been downloaded yet, please open this app with an internet connection.\n\nAfter the initial download the app can run offline and only requires an internet connection for updates." );
}




window.onerror = function (errorMsg, url, lineNumber, column, errorObj) 
{
	try
	{
		derror('Error: ' + errorMsg + ' Script: ' + url + ' Line: ' + lineNumber
		+ ' Column: ' + column + ' StackTrace: ' +  errorObj);
	}
	catch(e)
	{
		if( m_debug )
		{
			alert('Error: ' + errorMsg + ' Script: ' + url + ' Line: ' + lineNumber
			+ ' Column: ' + column + ' StackTrace: ' +  errorObj);
		}
		else
		{
			console.log('ERROR:' + errorMsg + ' Script: ' + url + ' Line: ' + lineNumber
			+ ' Column: ' + column + ' StackTrace: ' +  errorObj);
		}
	}
}

function set_app_name()
{
	// TODO: Set from database
	document.title = g_app_name;
	$('#appname_name').text(g_app_name);
	$('#appname_subname').text(g_app_subname);
}


// Called when the device is ready to run.  It will only execute once so safe to call more than once.
function onDeviceReady()
{
	if( m_has_loaded == false )
	{
		m_has_loaded = true;
		// Set up the slider object, it will add/remove other pages to this DOM element
		m_slider = new PageSlider($("#container"));
		on_app_first_load();
	}
}





function onDeviceReadyViaCordova()
{
	g_running_cordova = true;
	navigate_setup_back_button_handler();
	
	if( g_pushwoosh_enabled )
	{
		initPushwoosh();
		dalert( 'Using PushWoosh' );
	}
	onDeviceReady();
}



// Start the app (with or without cordova)
document.addEventListener("deviceready", onDeviceReadyViaCordova, false);
/*
setTimeout( function()
	{
		onDeviceReady();
		g_running_cordova = false;
	}, 
	4*1000 
);
*/
