function maphelper_show_gpslocation( gpslocation_id )
{
	maphelper_show( null, gpslocation_id );
}



function maphelper_show_gpstype( gpstype_id )
{
	maphelper_show( gpstype_id, null);
}



function maphelper_show( gpstype_id, gpslocation_id )
{
	var basepage = maphelper_getgpslocation_pagename();
	
	var params = "";
	
	if( gpstype_id != null )
	{
		params += 'gpstype_id='+gpstype_id;
	}
	
	if( gpslocation_id != null )
	{
		if( params != "" )
		{
			params += "&";
		}
		params += 'gpslocation_id='+gpslocation_id;
	}

	navigate_to_page( basepage+'?'+params);
}




// Determine if we should use google maps or bing maps
function maphelper_getgpslocation_pagename()
{
	var thisplatform = "unknown";
	try
	{
		thisplatform = device.platform;
	}
	catch(e)
	{
	}

	// Pick which way to show the map coordinates
	if( ( m_is_website ) ||
		( thisplatform == "Win32NT") ||
		( thisplatform == "WinCE") ||
		( thisplatform == "WP8.1") ||
		( thisplatform == "WP8") ||
		( thisplatform == "WP7") ||
		( thisplatform == "Win") )
	{
		pagename = "gpslocation_bing.html";
	}
	else
	{
		pagename = "gpslocation_google.html";
	}
	return pagename;
}
