function on_push_notification(event)
{
	var page = "news.html";

	try
	{
		//get the notification payload
		var notification = event.notification;
		var title = event.notification.title;
		
		if( title == null )
		{
			title = notification.aps.alert;
		}
		
                        //display alert to the user for example
		showalert("Notification", title);

		var userData = event.notification.userdata;
		
		//clear the app badge
		if( !IsWP8() )
		{
			if( typeof( pushNotification.setApplicationIconBadgeNumber ) != 'undefined' )
			{
				pushNotification.setApplicationIconBadgeNumber(0);
			}
		}
		

		if(typeof(userData) !== "undefined")
		{
			if( userData['page'] != null )
			{
				page = userData['page'];
			}
			//console.warn('user data: ' + JSON.stringify(userData));
//alert('user data: ' + page +' json:'+ JSON.stringify(userData));
		}
		else
		{
//alert( 'No userdata found');
		}

	}
	catch(e)
	{
		alert('New news article received');
	}
	navigate_to_page( page );
}


function initPushwoosh()
{
	if( !m_is_website )
	{
	    var pushNotification = null;
	
		if( window.plugins != null )
		{
			pushNotification = window.plugins.pushNotification;

		 
		    //set push notification callback before we initialize the plugin
		    document.addEventListener('push-notification', on_push_notification
			);
		 
		    //initialize the plugin
		    pushNotification.onDeviceReady(
				{
					projectid: g_pushnotification_pushwoosh_googleprojectid,
					pw_appid:g_pushnotification_pushwooshid,
					appid : g_pushnotification_pushwooshid, /* iOS,WP8 example */
					appname : g_app_name,
					serviceName : ""  /* From WP8 example*/
				}
			);
		     
		    //register for pushes
		    pushNotification.registerDevice(
		        function(status) {
		            var deviceToken = status['deviceToken'];
		            console.warn('registerDevice: ' + deviceToken);
		        },
		        function(status) {
		            console.warn('failed to register : ' + JSON.stringify(status));
		            dalert(JSON.stringify(['failed to register ', status]));
		        }
		    );
		     
		    //reset badges on app start
			if( !IsWP8() )
			{
				if( typeof( pushNotification.setApplicationIconBadgeNumber ) != 'undefined' )
			    {
					pushNotification.setApplicationIconBadgeNumber(0);
				}
			}
			dalert('Push Woosh enabled');
		}
		else  // if( window.plugins == null )
		{
			dalert( "window.plugins.pushNotification could not be found when setting up initPushwooh" );
		}
	}
}