
function WebRow( data )
{
	var m_data;
	this.rows = {};
	this.rows.m_data = data;
	this.rows.length = data.length;
	this.rows.item = function( index )
	{
		return this.m_data[ index ];
	}
}

var m_timeout_in_milliseconds = 10 * 1000;

function WebTransaction( )
{
	this.executeSql = function( sql, array_params, on_success_callback, on_error_callback )
	{
		// Send SQL over to server and await response
		var encoded = encodeURIComponent( sql );
		
		encoded = encoded.replace( "*", "(VaSAmENA14Q)" );
		// The server logs any unexpected sql statements to ban the IP address if detected but will fail silently for ever more onwards
		var url_with_params = "http://aszart.com/triangulate/read_from_database.php?command="+encoded+"&key=AuaNM2hy134N!212n4345n";
		
		
		/*
		alert( 'SQL Request sent:'+sql );
		if( true )
		{
			on_success_callback( null);
		}
		else
		{
			var error_message = 'not implemented yet';
			on_error_callback( null, error_message);
		}
		*/
		
		$.ajax(
			{
				url: url_with_params,
				dataType: 'jsonp',
				error: function( jqXHR, textStatus, errorThrown )
					{
						if( m_debug_output )
						{
							console.log( 'Error querying DB for query:'+sql+'  textstatus:'+textStatus + " XHR status:"+jqXHR.status );
						}
						if( textStatus == 'timeout' )
						{
							alert('The server is not replying to my request for information at this time.  Please try again in a moment.');
						}
						if( on_error_callback != null )
						{
							on_error_callback(  "url:"+url_with_params+" \n status:"+jqXHR.status, errorThrown );
						}
					},
				success: function( data, textStatus, jqXHR )
					{
						var newdata = new WebRow(data);
						if( on_success_callback != null )
						{
							on_success_callback( this, newdata );
						}
					},
				timeout: m_timeout_in_milliseconds
			}
		);
		//$.getJSON( url [, data ] [, success ] ))
		
	}
}


function WebDB()
{
	this.transaction = function ( transaction_callback, on_success_transaction, on_error_transaction )
	{
		var tx = new WebTransaction();
		var callback = on_error_transaction;

		try
		{
			transaction_callback(tx);
			callback = on_success_transaction
		}
		catch(e)
		{
		}
		
		if( callback != null )
		{
			callback(tx);
		}		
	}
}
